// THIS INCLUDE FILE  HAS BEEN MADE BY XAVIER LECLERCQ
// E-MAIL : xavierleclercq@iname.com
// WWW : http://www.geocities.com/SiliconValley/Park/2485/index.html
// THIS FILE MAKES TREES
// VERSION 1.05 SPECIAL
//
//////////////////////////////////////////////////////////////////////



// TEXTURES DECLARATIONS
//////////////////////////

#ifndef (BarkTexture)
 #declare BarkTexture = texture {
  pigment { color rgb<152/256,115/256,6/256> }
 }
#end

#ifndef (LeafTexture)
 #declare LeafTexture = texture {
  pigment { color rgb<0,1,0> }
 }
#end


// OBJECTS DECLARATION
////////////////////////

#ifndef (Leaf)
 #declare Leaf = mesh {
  triangle { <-0.2,0,0>,<0,0,0.6>,<0.2,0,0> }
  triangle { <-0.2,0,0>,<0,0.6,0>,<0.2,0,0> }
  triangle { <0,-0.2,0>,<0.6,0,0>,<0.2,0,0> }
  texture { LeafTexture }
 }
#end


// Trunk PARAMETERS
/////////////////////

#ifndef (TrunkLength)
 #declare TrunkLength = 17
#end
#ifndef (TrunkBase)
 #declare TrunkBase = 2
#end
#ifndef (TrunkMaxZ)
 #declare TrunkMaxZ = 0  // In degrees, should be greater than TrunkMinZ
#end
#ifndef (TrunkMinZ)
 #declare TrunkMinZ = TrunkMaxZ   // In degrees
#end
#ifndef (TrunkMaxNarrowing)
 #declare TrunkMaxNarrowing = 0.8
#end
#ifndef (TrunkMinNarrowing)
 #declare TrunkMinNarrowing = TrunkMaxNarrowing    // Should be greater than TrunkMaxNarrowing
#end
#ifndef (TrunkMaxBending)
 #declare TrunkMaxBending = 0     // In degrees, should be greater than TrunkMinBending
#end
#ifndef (TrunkMinBending)
 #declare TrunkMinBending = TrunkMaxBending    // In degrees
#end
#ifndef (TrunkPrecision)
 #declare TrunkPrecision = 10
#end
#ifndef (TrunkTextureOwn)
 #declare TrunkTextureOwn = 1
#end

#ifndef (SeedTrunkRotation)
 #declare SeedTrunkRotation = seed(10)
#end
#ifndef (SeedTrunkNarrowing)
 #declare SeedTrunkNarrowing = seed(147)
#end
#ifndef (SeedTrunkBending)
 #declare SeedTrunkBending = seed(50)
#end


// Limbs PARAMETERS
/////////////////////

#ifndef (LimbsVisible)
 #declare LimbsVisible = 1
#end
#ifndef (LimbsMaxLength)
 #declare LimbsMaxLength = 10 // Should be greater than LimbsMinLength
#end
#ifndef (LimbsMinLength)
 #declare LimbsMinLength = LimbsMaxLength
#end
#ifndef (LimbsMaxBase)
 #declare LimbsMaxBase = 1.5  // Should be greater than LimbsMinBase
#end
#ifndef (LimbsMinBase)
 #declare LimbsMinBase = LimbsMaxBase
#end
#ifndef (LimbsMaxNarrowing)
 #declare LimbsMaxNarrowing = 0.5
#end
#ifndef (LimbsMinNarrowing)
 #declare LimbsMinNarrowing = LimbsMaxNarrowing   // Should be greater than LimbsMaxNarrowing
#end
#ifndef (LimbsMaxN)
 #declare LimbsMaxN = 4   // Should be greater than LimbsMinN
#end
#ifndef (LimbsMinN)
 #declare LimbsMinN = LimbsMaxN
#end
#ifndef (LimbsMaxHeight)
 #declare LimbsMaxHeight = 1   // Should be greater than LimbsMinHeight
#end
#ifndef (LimbsMinHeight)
 #declare LimbsMinHeight = LimbsMaxHeight
#end
#ifndef (LimbsMaxZ)
 #declare LimbsMaxZ = 15    // In degrees, should be greater than LimbsMinZ
#end
#ifndef (LimbsMinZ)
 #declare LimbsMinZ = LimbsMaxZ    // In degrees
#end
#ifndef (LimbsMaxY)
 #declare LimbsMaxY = 360   // In degrees, should be greater than LimbsMinY
#end
#ifndef (LimbsMinY)
 #declare LimbsMinY = 0     // In degrees
#end
#ifndef (LimbsMaxBending)
 #declare LimbsMaxBending = -45  // In degrees, should be greater than LimbsMinBending
#end
#ifndef (LimbsMinBending)
 #declare LimbsMinBending = LimbsMaxBending  // In degrees
#end
#ifndef (LimbsPrecision)
 #declare LimbsPrecision = 10
#end
#ifndef (LimbsAntiRotation)
 #declare LimbsAntiRotation = 1
#end
#ifndef (LimbsTextureOwn)
 #declare LimbsTextureOwn = 1
#end
#ifndef (LimbsOnTop)
 #declare LimbsOnTop = 1
#end

#ifndef (SeedLimbsLength)
 #declare SeedLimbsLength = seed(40)
#end
#ifndef (SeedLimbsBase)
 #declare SeedLimbsBase = seed(5)
#end
#ifndef (SeedLimbsNarrowing)
 #declare SeedLimbsNarrowing = seed(10)
#end
#ifndef (SeedLimbsHeight)
 #declare SeedLimbsHeight = seed(7)
#end
#ifndef (SeedLimbsN)
 #declare SeedLimbsN = seed(12)
#end
#ifndef (SeedLimbsZ)
 #declare SeedLimbsZ = seed(65)
#end
#ifndef (SeedLimbsY)
 #declare SeedLimbsY = seed(10)
#end
#ifndef (SeedLimbsBending)
 #declare SeedLimbsBending = seed(52)
#end


// Boughs PARAMETERS
//////////////////////

#ifndef (BoughsVisible)
 #declare BoughsVisible = 1
#end
#ifndef (BoughsMaxLength)
 #declare BoughsMaxLength = 6   // Should be greater than BoughsMinLength
#end
#ifndef (BoughsMinLength)
 #declare BoughsMinLength = BoughsMaxLength
#end
#ifndef (BoughsMaxBase)
 #declare BoughsMaxBase = 0.7  // Should be greater than BoughsMinBase
#end
#ifndef (BoughsMinBase)
 #declare BoughsMinBase = BoughsMaxBase
#end
#ifndef (BoughsMaxNarrowing)
 #declare BoughsMaxNarrowing = 0.4
#end
#ifndef (BoughsMinNarrowing)
 #declare BoughsMinNarrowing = BoughsMaxNarrowing   // Should be greater than BoughsMaxNarrowing
#end
#ifndef (BoughsMaxN)
 #declare BoughsMaxN = 4   // Should be greater than BoughsMinN
#end
#ifndef (BoughsMinN)
 #declare BoughsMinN = BoughsMaxN
#end
#ifndef (BoughsMaxHeight)
 #declare BoughsMaxHeight = 1   // Should be greater than BoughsMinHeight
#end
#ifndef (BoughsMinHeight)
 #declare BoughsMinHeight = BoughsMaxHeight
#end
#ifndef (BoughsMaxZ)
 #declare BoughsMaxZ = 20    // In degrees, should be greater than BoughsMinZ
#end
#ifndef (BoughsMinZ)
 #declare BoughsMinZ = BoughsMaxZ    // In degrees
#end
#ifndef (BoughsMaxY)
 #declare BoughsMaxY = 360   // In degrees, should be greater than BoughsMinY
#end
#ifndef (BoughsMinY)
 #declare BoughsMinY = 0     // In degrees
#end
#ifndef (BoughsMaxBending)
 #declare BoughsMaxBending = -20  // In degrees, should be greater than BoughsMinBending
#end
#ifndef (BoughsMinBending)
 #declare BoughsMinBending = BoughsMaxBending  // In degrees
#end
#ifndef (BoughsPrecision)
 #declare BoughsPrecision = 10
#end
#ifndef (BoughsAntiRotation)
 #declare BoughsAntiRotation = 0
#end
#ifndef (BoughsTextureOwn)
 #declare BoughsTextureOwn = 0
#end
#ifndef (BoughsOnTop)
 #declare BoughsOnTop = 0
#end

#ifndef (SeedBoughsLength)
 #declare SeedBoughsLength = seed(56)
#end
#ifndef (SeedBoughsBase)
 #declare SeedBoughsBase = seed(21)
#end
#ifndef (SeedBoughsNarrowing)
 #declare SeedBoughsNarrowing = seed(26)
#end
#ifndef (SeedBoughsHeight)
 #declare SeedBoughsHeight = seed(23)
#end
#ifndef (SeedBoughsN)
 #declare SeedBoughsN = seed(28)
#end
#ifndef (SeedBoughsZ)
 #declare SeedBoughsZ = seed(49)
#end
#ifndef (SeedBoughsY)
 #declare SeedBoughsY = seed(29)
#end
#ifndef (SeedBoughsBending)
 #declare SeedBoughsBending = seed(36)
#end


// Branches variables
///////////////////////

#ifndef (BranchesVisible)
 #declare BranchesVisible = 1
#end
#ifndef (BranchesMaxLength)
 #declare BranchesMaxLength = 4 // Should be greater than BranchesMinLength
#end
#ifndef (BranchesMinLength)
 #declare BranchesMinLength = BranchesMaxLength
#end
#ifndef (BranchesMaxBase)
 #declare BranchesMaxBase = 0.3  // Should be greater than BranchesMinBase
#end
#ifndef (BranchesMinBase)
 #declare BranchesMinBase = BranchesMaxBase
#end
#ifndef (BranchesMaxNarrowing)
 #declare BranchesMaxNarrowing = 0.4
#end
#ifndef (BranchesMinNarrowing)
 #declare BranchesMinNarrowing = BranchesMaxNarrowing  // Should be greater than BranchesMaxNarrowing
#end
#ifndef (BranchesMaxN)
 #declare BranchesMaxN = 4   // Should be greater than BranchesMinN
#end
#ifndef (BranchesMinN)
 #declare BranchesMinN = BranchesMaxN
#end
#ifndef (BranchesMaxHeight)
 #declare BranchesMaxHeight = 1   // Should be greater than BranchesMinHeight
#end
#ifndef (BranchesMinHeight)
 #declare BranchesMinHeight = BranchesMaxHeight
#end
#ifndef (BranchesMaxZ)
 #declare BranchesMaxZ = 30    // In degrees, should be greater than BranchesMinZ
#end
#ifndef (BranchesMinZ)
 #declare BranchesMinZ = BranchesMaxZ    // In degrees
#end
#ifndef (BranchesMaxY)
 #declare BranchesMaxY = 360   // In degrees, should be greater than BranchesMinY
#end
#ifndef (BranchesMinY)
 #declare BranchesMinY = 0     // In degrees
#end
#ifndef (BranchesMaxBending)
 #declare BranchesMaxBending = -20  // In degrees, should be greater than BranchesMinBending
#end
#ifndef (BranchesMinBending)
 #declare BranchesMinBending = BranchesMaxBending  // In degrees
#end
#ifndef (BranchesPrecision)
 #declare BranchesPrecision = 10
#end
#ifndef (BranchesAntiRotation)
 #declare BranchesAntiRotation = 0
#end
#ifndef (BranchesTextureOwn)
 #declare BranchesTextureOwn = 0
#end
#ifndef (BranchesOnTop)
 #declare BranchesOnTop = 0
#end

#ifndef (SeedBranchesLength)
 #declare SeedBranchesLength = seed(41)
#end
#ifndef (SeedBranchesBase)
 #declare SeedBranchesBase = seed(1)
#end
#ifndef (SeedBranchesNarrowing)
 #declare SeedBranchesNarrowing = seed(6)
#end
#ifndef (SeedBranchesHeight)
 #declare SeedBranchesHeight = seed(32)
#end
#ifndef (SeedBranchesN)
 #declare SeedBranchesN = seed(68)
#end
#ifndef (SeedBranchesZ)
 #declare SeedBranchesZ = seed(9)
#end
#ifndef (SeedBranchesY)
 #declare SeedBranchesY = seed(3)
#end
#ifndef (SeedBranchesBending)
 #declare SeedBranchesBending = seed(86)
#end


// Twigs variables
////////////////////

#ifndef (TwigsVisible)
 #declare TwigsVisible = 1
#end
#ifndef (TwigsMaxLength)
 #declare TwigsMaxLength = 2 // Should be greater than TwigsMinLength
#end
#ifndef (TwigsMinLength)
 #declare TwigsMinLength = TwigsMaxLength
#end
#ifndef (TwigsMaxBase)
 #declare TwigsMaxBase = 0.1  // Should be greater than TwigsMinBase
#end
#ifndef (TwigsMinBase)
 #declare TwigsMinBase = TwigsMaxBase
#end
#ifndef (TwigsMaxNarrowing)
 #declare TwigsMaxNarrowing = 0.2
#end
#ifndef (TwigsMinNarrowing)
 #declare TwigsMinNarrowing = TwigsMaxNarrowing  // Should be greater than TwigsMaxNarrowing
#end
#ifndef (TwigsMaxN)
 #declare TwigsMaxN = 4   // Should be greater than TwigsMinN
#end
#ifndef (TwigsMinN)
 #declare TwigsMinN = TwigsMaxN
#end
#ifndef (TwigsMaxHeight)
 #declare TwigsMaxHeight = 1   // Should be greater than TwigsMinHeight
#end
#ifndef (TwigsMinHeight)
 #declare TwigsMinHeight = TwigsMaxHeight
#end
#ifndef (TwigsMaxZ)
 #declare TwigsMaxZ = 30    // In degrees, should be greater than TwigsMinZ
#end
#ifndef (TwigsMinZ)
 #declare TwigsMinZ = TwigsMaxZ    // In degrees
#end
#ifndef (TwigsMaxY)
 #declare TwigsMaxY = 360   // In degrees, should be greater than TwigsMinY
#end
#ifndef (TwigsMinY)
 #declare TwigsMinY = 0     // In degrees
#end
#ifndef (TwigsMaxBending)
 #declare TwigsMaxBending = -20  // In degrees, should be greater than TwigsMinBending
#end
#ifndef (TwigsMinBending)
 #declare TwigsMinBending = TwigsMaxBending  // In degrees
#end
#ifndef (TwigsPrecision)
 #declare TwigsPrecision = 10
#end
#ifndef (TwigsAntiRotation)
 #declare TwigsAntiRotation = 0
#end
#ifndef (TwigsTextureOwn)
 #declare TwigsTextureOwn = 0
#end
#ifndef (TwigsOnTop)
 #declare TwigsOnTop = 0
#end
#ifndef (TwigsLeavesVisible)
 #declare TwigsLeavesVisible = 1
#end

#ifndef (SeedTwigsLength)
 #declare SeedTwigsLength = seed(41)
#end
#ifndef (SeedTwigsBase)
 #declare SeedTwigsBase = seed(1)
#end
#ifndef (SeedTwigsNarrowing)
 #declare SeedTwigsNarrowing = seed(6)
#end
#ifndef (SeedTwigsHeight)
 #declare SeedTwigsHeight = seed(32)
#end
#ifndef (SeedTwigsN)
 #declare SeedTwigsN = seed(68)
#end
#ifndef (SeedTwigsZ)
 #declare SeedTwigsZ = seed(9)
#end
#ifndef (SeedTwigsY)
 #declare SeedTwigsY = seed(3)
#end
#ifndef (SeedTwigsBending)
 #declare SeedTwigsBending = seed(86)
#end





// Trunk variables
#declare RandTrunkRotation = rand(SeedTrunkRotation)
#declare RandTrunkNarrowing = rand(SeedTrunkNarrowing)
#declare RandTrunkBending = rand(SeedTrunkBending)

#declare TrunkBendingAngle = (TrunkMinBending+(TrunkMaxBending-TrunkMinBending)*RandTrunkBending)/TrunkPrecision
#declare TrunkNarrowing = (1-TrunkMaxNarrowing+(TrunkMinNarrowing-TrunkMaxNarrowing)*RandTrunkNarrowing)/TrunkPrecision
#declare TrunkUnitLength = TrunkLength/TrunkPrecision
#declare TrunkRotation = TrunkMinZ+(TrunkMaxZ-TrunkMinZ)*RandTrunkRotation

// Putting these values in the memory
#declare Memory = concat(str(TrunkBendingAngle,-11,6),str(TrunkNarrowing,-11,6),str(TrunkUnitLength,-11,6),str(TrunkRotation,-11,6))

 #declare LimbsN = LimbsMinN+(LimbsMaxN-LimbsMinN)*rand(SeedLimbsN) // doesn't change in the loop
 // Putting this value into the memory
 #declare Memory = concat(Memory,str(LimbsN,-11,6))

 #declare CountLimbs = 0
 #while (CountLimbs < LimbsN)
  #declare LimbLength = (LimbsMinLength+(LimbsMaxLength-LimbsMinLength)*rand(SeedLimbsLength))/LimbsPrecision
  #declare LimbBase = LimbsMinBase+(LimbsMaxBase-LimbsMinBase)*rand(SeedLimbsBase)
  #declare LimbNarrowing = (1-LimbsMaxNarrowing+(LimbsMinNarrowing-LimbsMaxNarrowing)*rand(SeedLimbsNarrowing))/LimbsPrecision
  #declare LimbHeight = (LimbsMinHeight+(LimbsMaxHeight-LimbsMinHeight)*rand(SeedLimbsHeight))*TrunkLength
  #declare LimbRotZ = LimbsMinZ+(LimbsMaxZ-LimbsMinZ)*rand(SeedLimbsZ)
  #declare LimbRotY = LimbsMinY+(LimbsMaxY-LimbsMinY)*rand(SeedLimbsY)
  #declare LimbBending = (LimbsMinBending+(LimbsMaxBending-LimbsMinBending)*rand(SeedLimbsBending))/LimbsPrecision
  // Putting these values into the memory
  #declare Memory = concat(Memory,str(LimbLength,-11,6),str(LimbBase,-11,6),str(LimbNarrowing,-11,6),str(LimbHeight,-11,6),str(LimbRotZ,-11,6),str(LimbRotY,-11,6),str(LimbBending,-11,6))

   #declare BoughsN = BoughsMinN+(BoughsMaxN-BoughsMinN)*rand(SeedBoughsN) // doesn't change in the loop
   // Putting this value into the memory
   #declare Memory = concat(Memory,str(BoughsN,-11,6))

   #declare CountBoughs = 0
   #while (CountBoughs < BoughsN)
    #declare BoughLength = (BoughsMinLength+(BoughsMaxLength-BoughsMinLength)*rand(SeedBoughsLength))/BoughsPrecision
    #declare BoughBase = BoughsMinBase+(BoughsMaxBase-BoughsMinBase)*rand(SeedBoughsBase)
    #declare BoughNarrowing = (1-BoughsMaxNarrowing+(BoughsMinNarrowing-BoughsMaxNarrowing)*rand(SeedBoughsNarrowing))/BoughsPrecision
    #declare BoughHeight = (BoughsMinHeight+(BoughsMaxHeight-BoughsMinHeight)*rand(SeedBoughsHeight))*LimbLength*LimbsPrecision
    #declare BoughRotZ = BoughsMinZ+(BoughsMaxZ-BoughsMinZ)*rand(SeedBoughsZ)
    #declare BoughRotY = BoughsMinY+(BoughsMaxY-BoughsMinY)*rand(SeedBoughsY)
    #declare BoughBending = (BoughsMinBending+(BoughsMaxBending-BoughsMinBending)*rand(SeedBoughsBending))/BoughsPrecision
    // Putting these values into the memory
    #declare Memory = concat(Memory,str(BoughLength,-11,6),str(BoughBase,-11,6),str(BoughNarrowing,-11,6),str(BoughHeight,-11,6),str(BoughRotZ,-11,6),str(BoughRotY,-11,6),str(BoughBending,-11,6))

    #declare BranchesN = BranchesMinN+(BranchesMaxN-BranchesMinN)*rand(SeedBranchesN) // doesn't change in the loop
    // Putting this value into the memory
    #declare Memory = concat(Memory,str(BranchesN,-11,6))

    #declare CountBranches = 0
     #while (CountBranches < BranchesN)
      #declare BranchLength = (BranchesMinLength+(BranchesMaxLength-BranchesMinLength)*rand(SeedBranchesLength))/BranchesPrecision
      #declare BranchBase = BranchesMinBase+(BranchesMaxBase-BranchesMinBase)*rand(SeedBranchesBase)
      #declare BranchNarrowing = (1-BranchesMaxNarrowing+(BranchesMinNarrowing-BranchesMaxNarrowing)*rand(SeedBranchesNarrowing))/BranchesPrecision
      #declare BranchHeight = (BranchesMinHeight+(BranchesMaxHeight-BranchesMinHeight)*rand(SeedBranchesHeight))*BoughLength*BoughsPrecision
      #declare BranchRotZ = BranchesMinZ+(BranchesMaxZ-BranchesMinZ)*rand(SeedBranchesZ)
      #declare BranchRotY = BranchesMinY+(BranchesMaxY-BranchesMinY)*rand(SeedBranchesY)
      #declare BranchBending = (BranchesMinBending+(BranchesMaxBending-BranchesMinBending)*rand(SeedBranchesBending))/BranchesPrecision
      // Putting these values into the memory
      #declare Memory = concat(Memory,str(BranchLength,-11,6),str(BranchBase,-11,6),str(BranchNarrowing,-11,6),str(BranchHeight,-11,6),str(BranchRotZ,-11,6),str(BranchRotY,-11,6),str(BranchBending,-11,6))

      #declare TwigsN = TwigsMinN+(TwigsMaxN-TwigsMinN)*rand(SeedTwigsN) // doesn't change in the loop
      // Putting this value into the memory
      #declare Memory = concat(Memory,str(TwigsN,-11,6))

      #declare CountTwigs = 0
       #while (CountTwigs < TwigsN)
        #declare TwigLength = (TwigsMinLength+(TwigsMaxLength-TwigsMinLength)*rand(SeedTwigsLength))/TwigsPrecision
        #declare TwigBase = TwigsMinBase+(TwigsMaxBase-TwigsMinBase)*rand(SeedTwigsBase)
        #declare TwigNarrowing = (1-TwigsMaxNarrowing+(TwigsMinNarrowing-TwigsMaxNarrowing)*rand(SeedTwigsNarrowing))/TwigsPrecision
        #declare TwigHeight = (TwigsMinHeight+(TwigsMaxHeight-TwigsMinHeight)*rand(SeedTwigsHeight))*BranchLength*BranchesPrecision
        #declare TwigRotZ = TwigsMinZ+(TwigsMaxZ-TwigsMinZ)*rand(SeedTwigsZ)
        #declare TwigRotY = TwigsMinY+(TwigsMaxY-TwigsMinY)*rand(SeedTwigsY)
        #declare TwigBending = (TwigsMinBending+(TwigsMaxBending-TwigsMinBending)*rand(SeedTwigsBending))/TwigsPrecision
        // Putting these values into the memory
        #declare Memory = concat(Memory,str(TwigLength,-11,6),str(TwigBase,-11,6),str(TwigNarrowing,-11,6),str(TwigHeight,-11,6),str(TwigRotZ,-11,6),str(TwigRotY,-11,6),str(TwigBending,-11,6))

        #declare CountTwigs = CountTwigs + 1
       #end

      #declare CountBranches = CountBranches + 1
     #end

    #declare CountBoughs = CountBoughs + 1
   #end

  #declare CountLimbs = CountLimbs + 1
 #end


// END OF MEMORY STOCK


